:: Setup Base Directory

mkdir "D:\Users"
cacls "D:\Users" /E /R "Authenticated Users"
cacls "D:\Users" /E /G "Everyone:R"

:: Copy the Default user profile to the new destination without links and junctions

robocopy C:\Users\Default D:\Users\Default\ /COPYALL /E /XJ

:: Populate the links and junctions in the Default user profile

mklink /J "D:\Users\Default\Application Data" "D:\Users\Default\AppData\Roaming"
mklink /J "D:\Users\Default\Cookies" "D:\Users\Default\AppData\Roaming\Microsoft\Windows\INetCookies"
mklink /J "D:\Users\Default\Local Settings" "D:\Users\Default\AppData\Local"
mklink /J "D:\Users\Default\My Documents" "D:\Users\Default\Documents"
mklink /J "D:\Users\Default\NetHood" "D:\Users\Default\AppData\Roaming\Microsoft\Windows\Network Shortcuts"
mklink /J "D:\Users\Default\PrintHood" "D:\Users\Default\AppData\Roaming\Microsoft\Windows\Printer Shortcuts"
mklink /J "D:\Users\Default\Recent" "D:\Users\Default\AppData\Roaming\Microsoft\Windows\Recent"
mklink /J "D:\Users\Default\SendTo" "D:\Users\Default\AppData\Roaming\Microsoft\Windows\SendTo"
mklink /J "D:\Users\Default\Start Menu" "D:\Users\Default\AppData\Roaming\Microsoft\Windows\Start Menu"
mklink /J "D:\Users\Default\Templates" "D:\Users\Default\AppData\Roaming\Microsoft\Windows\Templates"

mklink /J "D:\Users\Default\AppData\Local\Application Data" "D:\Users\Default\AppData\Local"
mklink /J "D:\Users\Default\AppData\Local\History" "D:\Users\Default\AppData\Local\Microsoft\Windows\History"
mklink /J "D:\Users\Default\AppData\Local\Temporary Internet Files" "D:\Users\Default\AppData\Local\Microsoft\Windows\INetCache"

mklink /J "D:\Users\Default\AppData\Local\Microsoft\Windows\Temporary Internet Files" "D:\Users\Default\AppData\Local\Microsoft\Windows\INetCache"

mklink /J "D:\Users\Default\Documents\My Music" "D:\Users\Default\Music"
mklink /J "D:\Users\Default\Documents\My Pictures" "D:\Users\Default\Pictures"
mklink /J "D:\Users\Default\Documents\My Videos" "D:\Users\Default\Videos"

mklink /J "D:\Users\Default User" "D:\Users\Default"

:: Set permissions on the links and junctions in the Default user profile

icacls "D:\Users\Default\Application Data" /deny "Everyone:(RD)"
icacls "D:\Users\Default\Cookies" /deny "Everyone:(RD)"
icacls "D:\Users\Default\Local Settings" /deny "Everyone:(RD)"
icacls "D:\Users\Default\My Documents" /deny "Everyone:(RD)"
icacls "D:\Users\Default\NetHood" /deny "Everyone:(RD)"
icacls "D:\Users\Default\PrintHood" /deny "Everyone:(RD)"
icacls "D:\Users\Default\Recent" /deny "Everyone:(RD)"
icacls "D:\Users\Default\SendTo" /deny "Everyone:(RD)"
icacls "D:\Users\Default\Start Menu" /deny "Everyone:(RD)"
icacls "D:\Users\Default\Templates" /deny "Everyone:(RD)"

icacls "D:\Users\Default\AppData\Local\Application Data" /deny "Everyone:(RD)"
icacls "D:\Users\Default\AppData\Local\History" /deny "Everyone:(RD)"
icacls "D:\Users\Default\AppData\Local\Temporary Internet Files" /deny "Everyone:(RD)"

icacls "D:\Users\Default\AppData\Local\Microsoft\Windows\Temporary Internet Files" /deny "Everyone:(RD)"

icacls "D:\Users\Default\Documents\My Music" /deny "Everyone:(RD)"
icacls "D:\Users\Default\Documents\My Pictures" /deny "Everyone:(RD)"
icacls "D:\Users\Default\Documents\My Videos" /deny "Everyone:(RD)"

icacls "D:\Users\Default User" /deny "Everyone:(RD)"

:: Copy the Public user profile to the new destination without links and junctions

robocopy C:\Users\Public D:\Users\Public\ /COPYALL /E /XJ

:: Populate the links and junctions in the Public user profile

mklink /J "D:\Users\Public\Documents\My Music" "D:\Users\Public\Music"
mklink /J "D:\Users\Public\Documents\My Pictures" "D:\Users\Public\Pictures"
mklink /J "D:\Users\Public\Documents\My Videos" "D:\Users\Public\Videos"

:: Set permissions on the links and junctions in the Public user profile

icacls "D:\Users\Public\Documents\My Music" /deny "Everyone:(RD)"
icacls "D:\Users\Public\Documents\My Pictures" /deny "Everyone:(RD)"
icacls "D:\Users\Public\Documents\My Videos" /deny "Everyone:(RD)"

:: Copy the ProgramData directory structure as best we can with no junctions or links while ignoring errors and suppressing output

robocopy C:\ProgramData D:\ProgramData\ /COPYALL /E /XJ /R:0 /W:0 /NS /NC /NFL /NDL /NJH /NJS /LOG:D:\robolog.txt
del D:\robolog.txt

:: Populate the links and junctions in the new ProgramData directory

mklink /J "D:\ProgramData\Application Data" "D:\ProgramData"
mklink /J "D:\ProgramData\Desktop" "D:\Users\Public\Desktop"
mklink /J "D:\ProgramData\Documents" "D:\Users\Public\Documents"
mklink /J "D:\ProgramData\Start Menu" "D:\ProgramData\Microsoft\Windows\Start Menu"
mklink /J "D:\ProgramData\Templates" "D:\ProgramData\Microsoft\Windows\Templates"

:: Set permissions on the links and junctions in the new ProgramData directory

icacls "D:\ProgramData\Application Data" /deny "Everyone:(RD)"
icacls "D:\ProgramData\Desktop" /deny "Everyone:(RD)"
icacls "D:\ProgramData\Documents" /deny "Everyone:(RD)"
icacls "D:\ProgramData\Start Menu" /deny "Everyone:(RD)"
icacls "D:\ProgramData\Templates" /deny "Everyone:(RD)"

:: Setup the All Users symbolic link and permissions

mklink /D "D:\Users\All Users" "D:\ProgramData"
icacls "D:\Users\All Users" /deny "Everyone:(RD)"

:: APply registry changes that make sure all new user accounts are setup on the D: drive

regedit /s Profile.reg